// $Id: TestCase.java,v 1.2 2003/08/13 18:41:02 queinnec Exp queinnec $

package fr.lip6.qnc.cfskit;

import junit.framework.*;

/** 
    This class redefines all assert* methods in order to count the number
    of assertions which is more interesting for the cfskit than the sole
    number of test* methods. These methods are originally defined in
    junit.framework.Assert.

    The number of assertions may be retrieved with the static variable
    count. See TestRun for an example.                                    FIXME.

**/

public class TestCase extends junit.framework.TestCase {

  public TestCase () {
  }

  public TestCase (String name) {
    super(name);
  }

  // Read from TestRun
  public static int count = 0;
  
  public static void assertEquals(boolean a, boolean b) {
    junit.framework.Assert.assertEquals(a, b);
    count++;
  }
  
  public static void assertEquals(byte a, byte b) {
    junit.framework.Assert.assertEquals(a, b);
    count++;
  }
  
  public static void assertEquals(char a, char b) {
    junit.framework.Assert.assertEquals(a, b);
    count++;
  }
    
  public static void assertEquals(double a, double b, double delta) {
    junit.framework.Assert.assertEquals(a, b, delta);
    count++;
  }
  
  public static void assertEquals(float a, float b, double delta) {
    junit.framework.Assert.assertEquals(a, b, delta);
    count++;
  }
  
  public static void assertEquals(int a, int b) {
    junit.framework.Assert.assertEquals(a, b);
    count++;
  }
  
  public static void assertEquals(long a, long b) {
    junit.framework.Assert.assertEquals(a, b);
    count++;
  }
  
  public static void assertEquals(Object a, Object b) {
    junit.framework.Assert.assertEquals(a, b);
    count++;
  }
  
  public static void assertEquals(short a, short b) {
    junit.framework.Assert.assertEquals(a, b);
    count++;
  }
  
  public static void assertEquals(String a, String b) {
    junit.framework.Assert.assertEquals(a, b);
    count++;
  }

  // Others

  public static void assertFalse (boolean a) {
    junit.framework.Assert.assertFalse(a);
    count++;
  }

  public static void assertNull (Object a) {
    junit.framework.Assert.assertNull(a);
    count++;
  }

  public static void assertSame (Object a, Object b) {
    junit.framework.Assert.assertSame(a, b);
    count++;
  }

  public static void assertTrue (boolean a) {
    junit.framework.Assert.assertTrue(a);
    count++;
  }

  //public static void fail () {
  //    junit.framework.Assert.fail();
  //}

  // The same with a message as first argument:
  
  public static void assertEquals(String message, boolean a, boolean b) {
    junit.framework.Assert.assertEquals(message, a, b);
    count++;
  }
  
  public static void assertEquals(String message, byte a, byte b) {
    junit.framework.Assert.assertEquals(message, a, b);
    count++;
  }
  
  public static void assertEquals(String message, char a, char b) {
    junit.framework.Assert.assertEquals(message, a, b);
    count++;
  }
    
  public static void assertEquals(String message, double a, double b, double delta) {
    junit.framework.Assert.assertEquals(message, a, b, delta);
    count++;
  }
  
  public static void assertEquals(String message, float a, float b, double delta) {
    junit.framework.Assert.assertEquals(message, a, b, delta);
    count++;
  }
  
  public static void assertEquals(String message, int a, int b) {
    junit.framework.Assert.assertEquals(message, a, b);
    count++;
  }
  
  public static void assertEquals(String message, long a, long b) {
    junit.framework.Assert.assertEquals(message, a, b);
    count++;
  }
  
  public static void assertEquals(String message, Object a, Object b) {
    junit.framework.Assert.assertEquals(message, a, b);
    count++;
  }
  
  public static void assertEquals(String message, short a, short b) {
    junit.framework.Assert.assertEquals(message, a, b);
    count++;
  }

  public static void assertEquals(String message, String a, String b) {
    junit.framework.Assert.assertEquals(message, a, b);
    count++;
  }
  // Others

  public static void assertFalse (String message, boolean a) {
    junit.framework.Assert.assertFalse(message, a);
    count++;
  }

  public static void assertNull (String message, Object a) {
    junit.framework.Assert.assertNull(message, a);
    count++;
  }

  public static void assertSame (String message, Object a, Object b) {
    junit.framework.Assert.assertSame(message, a, b);
    count++;
  }

  public static void assertTrue (String message, boolean a) {
    junit.framework.Assert.assertTrue(message, a);
    count++;
  }

  //public static void fail (String message, ) {
  //    junit.framework.Assert.fail(message);
  //}
  
}

// end of TestCase.java
