#! /usr/bin/perl

use diagnostics;
diagnostics::enable();
use DBI;

my $rundir = $ENV{'RT_RUN_DIR'};
my $logdir = $ENV{'RT_LOG_DIR'};
my $db = $ENV{'LOCAL_DB'};
my $dbprefix = $ENV{'LOCAL_DBPREFIX'};

my $date = `date`;

my $dbName = "dbi:Pg:dbname=$db host=localhost";
my $dbUserName = '';
my $dbUserPw = '';
my $traceDB = 0;    # See DB activity (within /var/log/http/error_log):

print "<html>
<head><title> Copies corrig&eacute;es </title></head>
<body><h1> R&eacute;sultats de correction </h1>
<div align='center'><table border=1>
";

my $dbh = DBI->connect($dbName, $dbUserName, $dbUserPw)
    || die "Cannot connect: " . $DBI::errstr;
$dbh->trace($traceDB) if $traceDB;
my $request = "select s.login, s.uuid, s.tgz, n.*
from ${dbprefix}_students_notes n, ${dbprefix}_student s
where n.sid = s.login
;";
my $sth = $dbh->prepare($request)
    || die "Cannot prepare request1: " . DBI::errstr;
$sth->execute()
    || die "Cannot execute request1: " . DBI::errstr;
my $emitHeaders = 1; # Emit column titles before 1st line
my @questions = ();
while ( my $row = $sth->fetchrow_hashref ) {
    if ( $emitHeaders ) {
        print "<tr><td></td>";
        foreach my $k (sort keys %{$row}) {
            if ( $k =~ /^q/i ) {
                push(@questions, $k);
                print "<th>$k</th>";
            };
        }
        print "<th>TOTAL</th></tr>\n";
        $emitHeaders = 0;
    };
    my $login = $row->{'login'};
    my $uuid = $row->{'uuid'};
    my $tgz = $row->{'tgz'};
    my ($shortlogin) = ( $tgz =~ /\/?(p6.*)\.tar\.gz/ );
    my $url = "http://127.0.0.1:56001$logdir/index.html"
        . "?uuid=$uuid&login=$shortlogin";
    print "<tr><td>
<a href='$logdir/$uuid/all.html' target='_blank'>$shortlogin</a></td>";
    my $total = 0;
    foreach my $k (@questions) {
        my $n = $row->{$k};
        if ( defined $n ) {
            $total += $n;
        } else {
            $n = '';
        }
        print "<td>$n</td>";
    }
    print "<td>$total</td>";
    print "<td>
<a href='$logdir/$uuid/' target='_blank'>LOG</a></td><td>
<a href='$rundir/$uuid/' target='_blank'>RUN</a></td><td>
<form method=post action='$url'><input type=submit value='re-noter!'></form>
</td></tr>
";
}
$sth->finish;
$dbh->disconnect;

print "</table></div><div align='center'><form method=post 
    action='http://127.0.0.1:56001$logdir/index.html?all=yes'>
<p> Re-noter toutes les copies ? 
    <input type=submit value='Tout re-noter!'>
</p></form></div>";

print "<hr>Engendr&eacute; le $date. </body></html>
";

# end of generate-index.pl
