#! /bin/sh
# Usage: $0 cct1-cfs algo prog archi reseau
# Construit des fichiers .csv par modules avec les notes de cct des etudiants
# de ces modules.

MAILEE=${MAILEE:-"Renee.Mouyal@ufr-info-p6.jussieu.fr Christian.Queinnec@lip6.fr"}
#MAILEE="Christian.Queinnec@lip6.fr"

# The host of the database:

DBFLAGS=${DBFLAGS:-"-h papillon"}

CCT=$1
TERM=$2
shift 2

# DEBUG
if [ "`hostname`" = 'perou.vld7net.fr' ]
then 
    DBFLAGS=
    MAILEE="queinnec"
fi

# Handle every module:

for M in "$@"
do 
    echo Building $M.sql ... 
    cat > /tmp/$M.sql <<eof
-- selectionner les inscrits au module:
create temp table Inscrit as
select distinct studentid 
from Inscription i
where i.moduleid = (select id 
                    from Lecture
                    where nickname = '$M');

-- extraire les seules notes concernees
create temp table extrait_note as
select distinct *
from Mark p
where p.epreuveid = (select moduleid 
                     from Epreuve 
                     where shortname = '$CCT'
                       and term = '$TERM');

\o /tmp/$M.csv

-- L'extraction des etudiants ayant une note de CCT:
select (  (select '"' || s.lastname || ', ' || lower(s.firstname) || '";'
           from Student s
           where s.studentid = p.studentid)
       || p.studentid || ';' 
       || max(p.mark) ) as line
from Mark p, Inscrit i
where p.epreuveid = (select moduleid 
                     from Epreuve 
                     where shortname = '$CCT'
                       and term = '$TERM' )
  and p.studentid = i.studentid
group by p.studentid
order by p.studentid;

-- FUTURE: C'est probablement un  LEFT OUTER JOIN

-- et l'extraction des etudiants n'ayant pas de note de CCT:
select (  (select '"' || s.lastname || ', ' || lower(s.firstname) || '";'
           from Student s
           where s.studentid = i.studentid)
       || i.studentid || ';' 
       || '"absent"' ) as line
from Inscrit i
where i.studentid not in (select studentid 
                          from extrait_note)
order by i.studentid;

\o
eof

    echo Building $M.csv ...
    psql licence $DBFLAGS -f /tmp/$M.sql
    ( echo "Voici les notes de CCT pour le module $M."
      echo "Engendrees depuis la base licence le `date`."
      echo 
      cat /tmp/$M.csv | sed -e '/;.*;/p' -e d | \
          sed -e 's/^ //' | sort -u > /tmp/s-$M.csv
      echo 
    ) > /tmp/$M.mail
    mutt -a /tmp/s-$M.csv -s "Notes CCT pour $M" ${MAILEE} < /tmp/$M.mail
done

# end of mk-csv-per-modules.sh
