#! /usr/bin/perl
# Ignore spaces, case and empty lines. As a special case, if the first 
# argument is --ignore-bad-exit-code then remove lines starting with the
# <!-- BadExitCodeWarning Start --> html comment and ending with the 
# <!-- BadExitCodeWarning Stop --> html comment. This comment tells
# whether a program stops with a bad exit code.

my $ignore_bad_exit_code = 0;
my $skip_lines = 0;

if ( $ARGV[0] eq '--ignore-bad-exit-code' ) {
    shift;
    $ignore_bad_exit_code = 1;
};

while ( <> ) {
    chomp;
    if ( $ignore_bad_exit_code ) {
        if ( /BadExitCodeWarning Start/ ) {
            $skip_lines = 1;
            next;
        } elsif ( /BadExitCodeWarning Stop/ ) {
            $skip_lines = 0;
            next;
        } elsif ( $skip_lines ) {
            next;
        }
    };
    tr /A-Z/a-z/;
    s/\s+//g;
    next if /^$/;
    print $_, "\n";
}

# end of norm.pl
