<?php 
// A single page to present 
//         a) the global results for all students
//         b) the results of a single student
//         c) the csv of all marks
// You get the first page with http://.../index.html
// You get the second page with http://.../index.html?id=1234567
// Additionally, http://.../index.html?stats=1 displays some statistics.

// Copy this file, edit it to your needs and make it visible by the students.

//******************************************************* Parameters
// Where's the css file ?
$css = "/licence/2002/licence.css";

// Who should be mailed in case of problems ?
$email = "Christian.Queinnec@lip6.fr";

// Database parameters:
// The name of the database:
$db_name = 'nlicence';
// The name of the DB user to incarnate when connecting to the db:
$db_user = 'plaquette';
// The password to use with this DB user:
$db_password ='a37596.86';
// Prefix for the SQL tables (normally the value of OTHER_DB_PREFIX):
$db_prefix = 'mlo2002';
// An array with the names of the formations to which this exam belongs:
$db_formations = array('maitrise-2003');

// Where are the deliverables (the tgz) ?
// By default, they're in the ./students/ subdirectory. 

$wwwPrefix = dirname($PHP_SELF);
$tgzPrefix = $wwwPrefix . "/students/";

// Where are the associated logs when marked. This directory should contain
// uuid subdirectories with a file named all.html. 
// By default, they're in the ./logs/ subdirectory:

$uuidPrefix = $wwwPrefix . "/logs/";

// The title of the page that presents all students' marks:
$title1 = 'Notes partiel MLO 2002';
// The title of the page that presents a single student's marks:
$title2 = $title1 . " (par tudiant)";

// What is the url leading to the description of a student. You may
// define this function or remove it entirely.

function compute_student_url ($student_id, $name)
{
     $baseUrl = "https://www.infop6.jussieu.fr/dbufr";
     $url = "$baseUrl/auths/seeStudent.php"
          . "?formation_name=licence-2003&term_id=2003oct"
          . "&dbufr_regular=1&student_id=$student_id";
     $img = "<img src='$baseUrl/public/student.png'  border=0>";
     return "<a href='$url'>$img $name</a>";
}

// Marks are recorded in the database question by question. The total
// should be computed by the following function that receives....
function compute_total ($marks) 
{
     // Parameters:
     $max = 50.0;       // Maximal mark
     $bias = 1.0;       // Scaling factor
     // end of parameters
     $total = 0.0;
     foreach ($marks as $m) {
          $total += $m;
     }
     return min($max, ceil($bias * $total));
}

//******************************************************* End of parameters
// Normally, no more modification beyond that point.

include("libcfskit.php");
$lesQuestions =& get_examination_questions($db_prefix);

// Display statistics and links towards students.
$stats = 0;
if ( array_key_exists('stats', $_GET) ) {
     $stats = $_GET['stats'];
};

if ( array_key_exists('csv', $_GET) ) {
     $csv = $_GET['csv'];
};
if ( isset($csv) && $csv>0 ) {

     // CSV generation

     header("Content-Type: application/vnd.ms-excel");
     header("Content-Disposition: attachment; filename=$db_prefix.csv");

     if ( array_key_exists('separator', $_GET) ) {
          $separator = $_GET['separator'];
     } else {
          $separator = 9; // Tabulation
     };
     $separator = chr($separator);

     echo "*** NumeroDossier ", $separator,
          "Nom", $separator, "prenom", $separator;
     foreach ($lesQuestions as $question) {
          echo $question, $separator;
     }
     echo "Total", $separator, "\n";

     // Generate a csv file with all marks and all students
     $lesEtudiants =& extract_all_students_marks($db_prefix);
     usort($lesEtudiants, "student_alpha_order");

     foreach ($lesEtudiants as $s) {
          echo '"', $s->id, '"', $separator, 
               '"', $s->lastname, '"', $separator,
               '"', $s->firstname, '"', $separator;
          $marks = array();
          foreach ($lesQuestions as $question) {
               $mark = $s->notes[$question];
               array_push($marks, $mark);
               $mark = eregi_replace(',', '.', $mark);
               echo $mark, $separator;
          }
          // Compute the total sum of marks:
          $total = compute_total($marks);
          echo $total, $separator, "\n";
     }
} else {

     // HTML Generation

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 Final//EN">
<!-- $Id: index.php,v 1.19 2004/04/20 12:55:08 queinnec Exp $ -->
<html><head><?php
if ( isset($css) ) {
     echo "<LINK rel=stylesheet type='text/css' href='$css'>";
}; 
if ( isset($title1) ) {
     echo "<META NAME='Keywords' CONTENT='$title1'>";
     echo "<META NAME='description' CONTENT='UPMC $title1'>";
};
if ( isset($email) ) {
     echo "<META NAME='Author' CONTENT='$email'>";
};
?> <META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=iso-8859-1">
   <META NAME="GENERATOR" CONTENT="Emacs">

<?php
// subclass Student to add the session field:

// If the student's id is sent, present these student's marks otherwise
// present all students' marks:

if ( array_key_exists('id', $_GET) ) {
     $id = $_GET["id"];
     // Sanitize student id:
     $id = eregi_replace("[^0-9]+", "", $id);

     // Present the marks of this precise student:

?>

   <title><?php echo $title2 ?></title>
</head><body><?php generate_common_bar($title2); ?>

<h1> <?php echo $title2 ?></h1>

<!-- Here you may add some code to display something towards a precise
     student. -->

<p>
Ces notes, temporaires, sont brutes et ne reprsentent que la valeur 
que le notateur a accord aux copies corriges. Vous pouvez soit 
rcuprer votre copie telle que soumise ou bien cliquer sur une
note pour obtenir le compte-rendu de correction de la question concerne.
</p>

<p align='center'><table align="center" style="font-size: 100%;" border=0>
<table><tr><td><?php echo $photo ?></td><td><table border=1><tr>
<th>Nom</th><th>Soumission</th><?php
foreach ($lesQuestions as $question) {
     echo "<th>$question</th>";
}
?></tr>

<?php
$lesSoumissions =& extract_cfs_submission($id, $lesQuestions);
usort($lesSoumissions, "tgz_before");
foreach ($lesSoumissions as $ss) {
     $url = $uuidPrefix . $ss->uuid . "/all.html";
     if (    $stats>0 
          && function_exists('compute_student_url') ) {
          $studentLink = compute_student_url($id, $ss->name);
          echo "<tr><td>$studentLink</td>";
     } else {
          echo "<tr><td>$ss->name</td>";
     }
     echo "<td><a href='${tgzPrefix}$ss->tgz'>",
          shorten_tgz($ss->tgz), "</a></td>";
     $total = 0.0;
     foreach ($lesQuestions as $question) {
          $total += $ss->notes[$question];
          echo "<td><a href=\"$url#$question\" target=\"_blank\"> "
               . $ss->notes[$question] . "</a></td>";
     }
     // Don't present the total of marks.
     echo "</tr>\n";
}

?></table></p></td></tr></table>

<?php
} else { 

     // Present all students' marks
?>

   <title><?php echo $title1 ?></title>
</head><body><?php generate_common_bar($title1); ?>

<h1> <?php echo $title1 ?></h1>

<!-- Here you may include some code to display a general text towards
      all students. -->

<?php
$lesEtudiants =& extract_all_students_marks($db_prefix);
usort($lesEtudiants, "student_alpha_order");
?><p>
Cette page contient les notes temporaires de <?php echo count($lesEtudiants) ?> 
tudiants. Ces notes sont brutes et ne reprsentent que la valeur 
que le notateur a accord aux copies corriges. Cliquez sur votre nom
pour obtenir votre copie corrige.
</p>

<p align="center"><table align="center" style="font-size: 100%;" border=1>
<th>Numro</th><th>Nom, prnom</th><?php
foreach ($lesQuestions as $question) {
     echo "<th>$question</th>";
}
?><th>Total</th></tr>

<?php
$allMarks = array();
foreach ($lesEtudiants as $s) {
     echo "<tr><td>" . $s->id . "</td><td>" 
          . generate_cfs_details($s) . "</td>";
     $marks = array();
     foreach ($lesQuestions as $question) {
          $mark = $s->notes[$question];
          array_push($marks, $mark);
          echo "<td>", $mark, "</td>";
     }
     // Compute the total sum of marks:
     $total = compute_total($marks);
     echo "<td align=\"right\">", $total, "</td></tr>\n";
     // Record for the 'record=1' query parameter:
     $s->final = $total;
     // For statistics
     $allMarks[] = $total;
}

?></table></p>

<?php 
         // Display statistics
if ( array_key_exists('stats', $_GET) ) {
     $stats = $_GET['stats'];
};
if ( isset($stats) && $stats>0 ) {
     $results =& computeStatistics($allMarks);
     echo "<p> La moyenne (aprs arrondi) est de ", round($results[0], 2), 
          " et l'cart-type de ", round($results[1], 2), ". ";
?>

Le <a href='<?php echo $PHP_SELF . "?csv=1" ?>'> fichier CSV</a> 
est aussi disponible.</p>

<?php
     };
} ?>

<hr>
<a href="mailto:<?php echo $email ?>">Remarques?</a>
&nbsp;&nbsp;&nbsp;<tt><?php 
echo "\$Id: index.php,v 1.19 2004/04/20 12:55:08 queinnec Exp $" ?></tt><br>
Extrait de la base  <?php echo $db_name ?>  
le <?php echo date("j F Y  G:i:s\.") ?>
</body></html>
<?php
} 
?>
