#! /usr/bin/perl
# Count occurrences of a string in stdin

my $usage = "count.pl [-i] [-regexp regexp | string]
Copyright (C) 2002 by <Christian.Queinnec@lip6.fr> $Revision: 1.1 $
Counts the number of times string is seen in the standard input. 
Returns that number in the standard output. 
Option -i is for case insensitivity.
Option -regexp means that the following string is in fact a regexp.
";

my $string;
my $insensitive = 0;
my $quotemeta = 1;

foreach (@ARGV) {
    if ( /^-i$/ ) {
        $insensitive = 1;
        next;
    } elsif ( /^-regexp$/ ) {
        $quotemeta = 0;
        next;
    } elsif ( /-(h|-help)$/ ) {
        die $usage;
    } else {
        $string = $_;
        next;
    }
}

$string = quotemeta($string) if $quotemeta;
my $count = 0;

while ( <STDIN> ) {
    if ( $insensitive ) {
        while ( s/$string//i ) {
            $count++;
        }
    } else {
        while ( s/$string// ) {
            $count++;
        }        
    }
}
print $count, "\n";
    
# end of count.pl
