-- $Id: create.sql,v 1.9 2002/06/30 06:13:07 queinnec Exp $
-- Creer les tables pour stocker les notes d'un cfs.
-- QNC: C'est aussi indique dans le debut de extract.pl

-- \set STUDENT   dth5_student
-- \set MARK      dth5_mark
-- \set FACT      dth5_fact
-- \set INSERTER  manoury
-- \set PHP       plaquette

-- Les trois premieres variables indiquent le nom des tables, les deux
-- suivantes indiquent le nom de l'utilisateur qui peut inserer des
-- enregistrements dans les tables et le nom de l'utilisateur qui peut
-- seulement lire ces tables (c'est ce nom qu'empruntent les formulaires
-- PHP permettant aux etudiants de lire leurs notes).

-- Les tables

-- Cette table recense tous les etudiants ayant compose l'epreuve.
-- Pour chacun on enregistre
--       uuid       le numero de la (ou d'une) copie
--       login      leur login (donne par delbul)
--       tgz        le chemin d'acces au tgz de la copie
--       session    l'identificateur de l'epreuve (dth5, cfs, ...)
--       final      [un champ qui contiendra in fine la note finale, rectifiee
--                   de ce CFS ou DTH. Elle sera incorporee plus tard a la
--                   table Mark de la base de licence.]

create table :STUDENT (
       uuid     text not null,
       login    text not null,
       tgz      text not null,
       session  text not null,
       final    float,
       primary key (uuid, login)
);
revoke all   on :STUDENT from public;
grant select on :STUDENT to :PHP;
grant all    on :STUDENT to :INSERTER;

-- Cette table recense les notes de chaque question d'une copie
-- identifiee par son numero (uuid). 

create table :MARK (
       uuid     text not null,
       question text not null,
       mark     float not null,
       primary key (uuid, question)
);
revoke all   on :MARK from public;
grant select on :MARK to :PHP;
grant all    on :MARK to :INSERTER;

-- Cette table enregistre des faits (numeriques ou textuels) quelconques.
-- Ces faits concernent une copie (uuid) et une question.
-- Le fait a une cle (label) qui permet de faire des statistiques. 
-- L'information associee est soit un nombre flottant (number) ou une
-- chaine de caracteres (phrase). Cette table generalise l'ancienne table
-- duration qui enregistrait la duree des programmes. 

create table :FACT (
       uuid     text not null,
       question text not null,
       label    text not null,
       number   float,
       phrase   text
);
revoke all   on :FACT from public;
grant select on :FACT to :PHP;
grant all    on :FACT to :INSERTER;

-- fin
