#! /usr/bin/perl
# Add HTML prefix and suffix. Massage a little the HTML content to introduce
# name anchors for every section. Take care also of repeated lines.

use diagnostics;
diagnostics::enable();
use strict;

my $uuid = shift;
my $alltoc = shift;

# Global variables:

my $threshold = 5;
my $preprevious = '';
my $previous = '';
my $count = 0;

my $css;
if ( defined $ENV{'RT_CSS'} ) {
    $css = $ENV{'RT_CSS'};
} else {
    $css = '/licence/cfs.css';
}

# Prologue:

print "<html>
<head><title> Dtails de notation </title>
<meta http-equiv='Content-Type' content='text/html; charset=iso-8859-1'>
<link rel=stylesheet type='text/css' href='$css'>
</head><body><div class='CFSKIT'>
";

while ( <> ) {
    # Insert the table of sections
    if ( /cfskitTOC\: here will appear the table of sections \:COTtiksfc/ ) {
        print `cat $alltoc`;
        $previous = '';
        $count = 0;
    };
    # Take care of multiple similar lines: this is useful for looping 
    # programs.
    if ( $previous eq $_ ) {
        $count++;
        next;
    } elsif ( $count >= $threshold ) {
        chomp($previous);
        print $previous . " <span class=\"WARNING\">... " 
            . "(en fait $count lignes similaires) ...</span>\n";
    } elsif ( $count > 0 ) {
        foreach my $i (1 .. $count) {
            print $previous;
        }
    } else {
        # nothing
    }
    $count = 0;
    $previous = $_;
    print;
}

# when eof is found while accumulating similar lines:

if ( $count >= $threshold ) {
    chomp($previous);
    print $previous . " <span class=\"WARNING\">... " 
        . "(en fait $count lignes similaires) ...</span>\n";
} elsif ( $count > 0 ) {
    foreach my $i (1 .. $count) {
        print $previous;
    }
};

# Epilogue

print "
</div>
</body>
</html>
";

# end of log2html.pl
