-- $Id: stat.sql,v 1.14 2003/12/29 21:53:25 queinnec Exp $
-- Les traitements en masse

-- Ce script SQL suppose qu'il existe une table Login
--       avec un champ 'login' et un champ 'student_id'
-- et une table Person 
--       avec un champ 'id' et des champs 'lastname', 'firstname'.
-- Une jointure sera effectuee entre Login.student_id et Person.id.

-- L'invoqueur doit indiquer quelles sont les tables a utiliser:
--\set STUDENT   cfs2003dec17am_student
--\set MARK      cfs2003dec17am_mark
--\set FACT      cfs2003dec17am_fact

\echo 
\echo ********** Min, moyenne et max par session et par question:

-- Calculer les moyennes par session et question:
select cs.session, cm.question, count(cm.mark), 
       min(cm.mark), avg(cm.mark), max(cm.mark)
from :STUDENT cs, :MARK cm
where cm.uuid = cs.uuid
group by cs.session, cm.question
order by cs.session, cm.question;

--drop table cfs_results;
create temp table cfs_results as
select cs.login, cs.session, cm.question, max(cm.mark) as mark
from :STUDENT cs, :MARK cm
where cm.uuid = cs.uuid
group by cs.login, cs.session, cm.question;

--drop table cfs_notes;
create temp table cfs_notes as
select sum(mark) as total
from cfs_results
group by login;

--select avg(total), max(total)
--from cfs_notes;

\echo ********** Min, moyenne et max par notes d etudiant par session:

--drop table cfs_student_note;
create temp table cfs_student_note as
select session, login, sum(mark) as mark
from cfs_results
group by session, login;

select session, count(mark) || ' copies' as count, 
       min(mark), avg(mark), max(mark)
from cfs_student_note
group by session;

\echo ********** Quelques comptes de faits par question:

select f.question, f.label, 
       f.phrase as fact, 
       count(f.phrase) as nombre
from :FACT f
group by f.question, f.label, f.phrase
  union
select f.question, f.label, 
       cast(f.number as text) as fact, 
       count(f.number) as nombre
from :FACT f
group by f.question, f.label, f.number;

-- fin.
