#! /bin/sh
# Calculer des statistiques pour mettre au point un CFS.
# Cf. exemple dans CFS2002jun05/Imakefile

# La base est supposee ne pas exister. On la cree:
createdb ${LOCAL_DB}

# et on commence a construire les programmes sql adaptes:
SQL=/tmp/t.sql

# (1) creer les tables
cat ${CFSKIT_DIR}/create.sql > ${SQL}

# (1a) et la table des etudiants correspondant aux pseudo-copies:
# Elle a la meme structure que la table student dans la base licence.
cat >> ${SQL} <<EOF
create table student (
  studentid text primary key, 
  lastname text, 
  firstname text, 
  login text
);
EOF

# (2) remplir la table des pseudo-etudiants en fonction des copies:
for s in `cd pseudos && echo *`
do
    echo $s | sed -e 's;_.*$;;' 
done | while read s
do
    echo "insert into student values('$s', '$s', '$s', '$s');"
done >> ${SQL}

echo '\echo insertion des notes et faits'  >> ${SQL}

# (3) collationner tous les morceaux de sql
cat ${RT_LOG_DIR}/*/all.sql >> ${SQL}

# (4) tout rentrer en base
psql ${LOCAL_DB} ${LOCAL_DBFLAGS} -f ${SQL} 2>/dev/null

# (5) calculer l'ensemble des questions
echo 'select distinct question from :MARK;' | \
    psql ${LOCAL_DB} ${LOCAL_DBFLAGS} -t > /tmp/q
export Q=`cat /tmp/q`
rm -f /tmp/q

# Creer une table des notes, la remplir et l'afficher
( # On definit la table:
  echo "create table ${LOCAL_DBPREFIX}_students_notes (sid text references student "
  for q in $Q
  do 
    echo "    , $q float"
  done
  echo ');'

  # On la remplit
  echo "insert into ${LOCAL_DBPREFIX}_students_notes select studentid "
  for q in $Q
  do 
     echo ", null"
  done
  echo " from student;"

  # Puis on la modifie
  for q in $Q
  do 
    echo "update ${LOCAL_DBPREFIX}_students_notes
  set $q = r.mark
from ${LOCAL_DBPREFIX}_mark r, ${LOCAL_DBPREFIX}_student s
where sid = s.login
  and r.uuid = s.uuid 
  and r.question = '${q}';
"
  done
  echo "select * from ${LOCAL_DBPREFIX}_students_notes;"
  cat ${CFSKIT_DIR}/stat.sql
) > ${SQL}

# Executer:
psql ${LOCAL_DB} ${LOCAL_DBFLAGS} -f ${SQL} 2>/dev/null

# Nettoyer:
rm ${SQL}

# end of test-stat.sh
